"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const PouchDB = require("pouchdb");
const pouch_connection_req_1 = require("./msgs/pouch-connection-req");
const pouch_connection_res_1 = require("./msgs/pouch-connection-res");
PouchDB.plugin(require('pouchdb-find'));
class PouchConnectionPoolProcessor {
    // private readonly writeActions: Map<string, FragmentWriteReq[]>;
    static create(msgBus) {
        return new PouchConnectionPoolProcessor(msgBus);
    }
    constructor(msgBus) {
        this.pouchDbs = new Map();
        msgBus.subscribe(msg => {
            pouch_connection_req_1.PouchConnectionReq.is(msg).match(pcr => {
                let c = this.pouchDbs.get(pcr.config.path);
                if (!c) {
                    const pouchDb = new PouchDB(pcr.config.path, pcr.config.dbConfig);
                    c = new pouch_connection_res_1.PouchConnectionRes({
                        tid: '',
                        config: pcr.config,
                        pouchDb: pouchDb
                    });
                    this.pouchDbs.set(pcr.config.path, c);
                }
                msgBus.next(new pouch_connection_res_1.PouchConnectionRes({
                    tid: pcr.tid,
                    config: c.config,
                    pouchDb: c.pouchDb
                }));
            });
        });
    }
}
exports.PouchConnectionPoolProcessor = PouchConnectionPoolProcessor;
//# sourceMappingURL=pouch-connection-pool-processor.js.map