"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const msg_1 = require("./msg");
class Match {
    constructor(t) {
        // console.log('Match:', t);
        this.msg = t;
    }
    static create(t) {
        return new Match(t);
    }
    static nothing() {
        return new Match(null);
    }
    hasTid(msg) {
        let msgTid;
        if ((msg instanceof msg_1.Msg) && this.msg) {
            msgTid = msg.tid;
        }
        else if (typeof (msg) == 'string') {
            msgTid = msg;
        }
        if (this.msg && msgTid === this.msg.tid) {
            return this;
        }
        return Match.nothing();
    }
    get matched() {
        return !!this.msg;
    }
    match(cb) {
        if (this.msg) {
            cb(this.msg);
        }
    }
}
exports.Match = Match;
//# sourceMappingURL=match.js.map