"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const uuid = require("uuid");
const path = require("path");
const fs_1 = require("fs");
const chai_1 = require("chai");
const index_1 = require("../src/index");
describe('pouchdb connection pool', () => {
    before((done) => {
        fs_1.mkdir('.pdb', () => done());
    });
    it('create-connection', (done) => {
        const bus = new index_1.MsgBus();
        let pouchDb;
        let tid = uuid.v4();
        index_1.PouchConnectionPoolProcessor.create(bus);
        bus.subscribe(msg => {
            index_1.PouchConnectionRes.is(msg).hasTid(tid).match(pcr => {
                pcr.pouchDb.get('testId').then(r => {
                    chai_1.assert.fail('never call');
                }).catch(e => {
                    try {
                        if (e.name == 'not_found') {
                            if (!pouchDb) {
                                pouchDb = pcr.pouchDb;
                                tid = uuid.v4();
                                bus.next(new index_1.PouchConnectionReq(tid, {
                                    path: pcr.config.path
                                }));
                            }
                            else {
                                chai_1.assert.equal(pouchDb, pcr.pouchDb);
                                done();
                            }
                        }
                        else {
                            chai_1.assert.fail('never call');
                        }
                    }
                    catch (e) {
                        done(e);
                    }
                });
            });
        });
        bus.next(new index_1.PouchConnectionReq(tid, {
            path: path.join('.pdb', tid)
        }));
    });
});
//# sourceMappingURL=pouch-connection-pool-test.js.map